// ==============================================================
// RTL generated by Vitis HLS - High-Level Synthesis from C, C++ and OpenCL v2022.1 (64-bit)
// Version: 2022.1
// Copyright (C) Copyright 1986-2022 Xilinx, Inc. All Rights Reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

module cache_module_cache_module_Pipeline_VITIS_LOOP_20_2 (
        ap_clk,
        ap_rst,
        ap_start,
        ap_done,
        ap_idle,
        ap_ready,
        bf_lshr_cast,
        trunc_ln7,
        cacheMemory_load_2_out,
        cacheMemory_load_2_out_ap_vld,
        cacheMemory_address0,
        cacheMemory_ce0,
        cacheMemory_q0,
        ap_return
);

parameter    ap_ST_fsm_state1 = 5'd1;
parameter    ap_ST_fsm_state2 = 5'd2;
parameter    ap_ST_fsm_state3 = 5'd4;
parameter    ap_ST_fsm_state4 = 5'd8;
parameter    ap_ST_fsm_state5 = 5'd16;

input   ap_clk;
input   ap_rst;
input   ap_start;
output   ap_done;
output   ap_idle;
output   ap_ready;
input  [0:0] bf_lshr_cast;
input  [28:0] trunc_ln7;
output  [63:0] cacheMemory_load_2_out;
output   cacheMemory_load_2_out_ap_vld;
output  [2:0] cacheMemory_address0;
output   cacheMemory_ce0;
input  [63:0] cacheMemory_q0;
output  [0:0] ap_return;

reg ap_done;
reg ap_idle;
reg ap_ready;
reg cacheMemory_load_2_out_ap_vld;
reg cacheMemory_ce0;
reg[0:0] ap_return;

(* fsm_encoding = "none" *) reg   [4:0] ap_CS_fsm;
wire    ap_CS_fsm_state1;
wire   [0:0] icmp_ln20_fu_114_p2;
reg   [0:0] icmp_ln20_reg_182;
wire    ap_CS_fsm_state2;
wire   [2:0] add_ln20_fu_120_p2;
reg   [2:0] add_ln20_reg_186;
reg   [63:0] cacheMemory_load_reg_196;
wire    ap_CS_fsm_state3;
reg   [0:0] ap_phi_mux_UnifiedRetVal_phi_fu_98_p4;
reg   [0:0] UnifiedRetVal_reg_94;
wire    ap_CS_fsm_state5;
wire    ap_CS_fsm_state4;
wire   [63:0] zext_ln21_fu_137_p1;
reg   [2:0] i_fu_58;
wire   [0:0] icmp_ln21_fu_156_p2;
wire   [0:0] trunc_ln21_1_fu_142_p1;
wire   [1:0] trunc_ln21_fu_126_p1;
wire   [2:0] lshr_ln2_fu_130_p3;
wire   [28:0] trunc_ln21_3_fu_146_p4;
reg   [0:0] ap_return_preg;
reg   [4:0] ap_NS_fsm;
reg    ap_ST_fsm_state1_blk;
wire    ap_ST_fsm_state2_blk;
wire    ap_ST_fsm_state3_blk;
wire    ap_ST_fsm_state4_blk;
wire    ap_ST_fsm_state5_blk;
wire    ap_ce_reg;

// power-on initialization
initial begin
#0 ap_CS_fsm = 5'd1;
#0 ap_return_preg = 1'd0;
end

always @ (posedge ap_clk) begin
    if (ap_rst == 1'b1) begin
        ap_CS_fsm <= ap_ST_fsm_state1;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst == 1'b1) begin
        ap_return_preg <= 1'd0;
    end else begin
        if ((1'b1 == ap_CS_fsm_state4)) begin
            ap_return_preg <= ap_phi_mux_UnifiedRetVal_phi_fu_98_p4;
        end
    end
end

always @ (posedge ap_clk) begin
    if (((icmp_ln20_reg_182 == 1'd0) & (1'b1 == ap_CS_fsm_state4))) begin
        UnifiedRetVal_reg_94 <= 1'd0;
    end else if ((1'b1 == ap_CS_fsm_state5)) begin
        UnifiedRetVal_reg_94 <= 1'd1;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1))) begin
        i_fu_58 <= 3'd0;
    end else if (((1'b1 == ap_CS_fsm_state3) & (((trunc_ln21_1_fu_142_p1 == 1'd0) & (icmp_ln20_reg_182 == 1'd0)) | ((icmp_ln21_fu_156_p2 == 1'd0) & (icmp_ln20_reg_182 == 1'd0))))) begin
        i_fu_58 <= add_ln20_reg_186;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state2)) begin
        add_ln20_reg_186 <= add_ln20_fu_120_p2;
        icmp_ln20_reg_182 <= icmp_ln20_fu_114_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((icmp_ln20_reg_182 == 1'd0) & (1'b1 == ap_CS_fsm_state3))) begin
        cacheMemory_load_reg_196 <= cacheMemory_q0;
    end
end

always @ (*) begin
    if ((ap_start == 1'b0)) begin
        ap_ST_fsm_state1_blk = 1'b1;
    end else begin
        ap_ST_fsm_state1_blk = 1'b0;
    end
end

assign ap_ST_fsm_state2_blk = 1'b0;

assign ap_ST_fsm_state3_blk = 1'b0;

assign ap_ST_fsm_state4_blk = 1'b0;

assign ap_ST_fsm_state5_blk = 1'b0;

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state4) | ((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b0)))) begin
        ap_done = 1'b1;
    end else begin
        ap_done = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b0))) begin
        ap_idle = 1'b1;
    end else begin
        ap_idle = 1'b0;
    end
end

always @ (*) begin
    if (((icmp_ln20_reg_182 == 1'd0) & (1'b1 == ap_CS_fsm_state4))) begin
        ap_phi_mux_UnifiedRetVal_phi_fu_98_p4 = 1'd0;
    end else begin
        ap_phi_mux_UnifiedRetVal_phi_fu_98_p4 = UnifiedRetVal_reg_94;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state4)) begin
        ap_ready = 1'b1;
    end else begin
        ap_ready = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state4)) begin
        ap_return = ap_phi_mux_UnifiedRetVal_phi_fu_98_p4;
    end else begin
        ap_return = ap_return_preg;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state2)) begin
        cacheMemory_ce0 = 1'b1;
    end else begin
        cacheMemory_ce0 = 1'b0;
    end
end

always @ (*) begin
    if (((icmp_ln20_reg_182 == 1'd0) & (1'b1 == ap_CS_fsm_state4))) begin
        cacheMemory_load_2_out_ap_vld = 1'b1;
    end else begin
        cacheMemory_load_2_out_ap_vld = 1'b0;
    end
end

always @ (*) begin
    case (ap_CS_fsm)
        ap_ST_fsm_state1 : begin
            if (((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end
        end
        ap_ST_fsm_state2 : begin
            ap_NS_fsm = ap_ST_fsm_state3;
        end
        ap_ST_fsm_state3 : begin
            if (((1'b1 == ap_CS_fsm_state3) & (((trunc_ln21_1_fu_142_p1 == 1'd0) & (icmp_ln20_reg_182 == 1'd0)) | ((icmp_ln21_fu_156_p2 == 1'd0) & (icmp_ln20_reg_182 == 1'd0))))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else if (((icmp_ln20_reg_182 == 1'd1) & (1'b1 == ap_CS_fsm_state3))) begin
                ap_NS_fsm = ap_ST_fsm_state5;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state4;
            end
        end
        ap_ST_fsm_state4 : begin
            ap_NS_fsm = ap_ST_fsm_state1;
        end
        ap_ST_fsm_state5 : begin
            ap_NS_fsm = ap_ST_fsm_state4;
        end
        default : begin
            ap_NS_fsm = 'bx;
        end
    endcase
end

assign add_ln20_fu_120_p2 = (i_fu_58 + 3'd1);

assign ap_CS_fsm_state1 = ap_CS_fsm[32'd0];

assign ap_CS_fsm_state2 = ap_CS_fsm[32'd1];

assign ap_CS_fsm_state3 = ap_CS_fsm[32'd2];

assign ap_CS_fsm_state4 = ap_CS_fsm[32'd3];

assign ap_CS_fsm_state5 = ap_CS_fsm[32'd4];

assign cacheMemory_address0 = zext_ln21_fu_137_p1;

assign cacheMemory_load_2_out = cacheMemory_load_reg_196;

assign icmp_ln20_fu_114_p2 = ((i_fu_58 == 3'd4) ? 1'b1 : 1'b0);

assign icmp_ln21_fu_156_p2 = ((trunc_ln21_3_fu_146_p4 == trunc_ln7) ? 1'b1 : 1'b0);

assign lshr_ln2_fu_130_p3 = {{bf_lshr_cast}, {trunc_ln21_fu_126_p1}};

assign trunc_ln21_1_fu_142_p1 = cacheMemory_q0[0:0];

assign trunc_ln21_3_fu_146_p4 = {{cacheMemory_q0[30:2]}};

assign trunc_ln21_fu_126_p1 = i_fu_58[1:0];

assign zext_ln21_fu_137_p1 = lshr_ln2_fu_130_p3;

endmodule //cache_module_cache_module_Pipeline_VITIS_LOOP_20_2
